
let Run = require('./scripts/run');
module.exports = {
    Setup : function (params, next, worker, processes, failed) {
        let cluster = require('cluster');
        if (cluster.isMaster) {
            if (typeof next === 'function') {
                /**
                 * next: is worker, worker: is process, process: is failed
                 */
                Run().then(function () {
                    let cpus = require('os').cpus().length;
                    console.log('Forking S_Loc_Instance Version', require('./package.json').version);
                    for (let i = 0; i < cpus; i += 1) {
                        let workerP = cluster.fork();
                        if (worker) {
                            workerP.on('message', function (message) {
                                next(message);
                            });
                        }
                    }
                    params(function (parameters) {
                        console.log('Ran Parameters')
                    })
                }).catch(processes);
            } else {
                Run(next).then(function () {
                    let cpus = require('os').cpus().length;
                    console.log('Forking S_Loc_Instance Version', require('./package.json').version);
                    for (let i = 0; i < cpus; i += 1) {
                        let workerP = cluster.fork();
                        if (worker) {
                            workerP.on('message', function (message) {
                                worker(message);
                            });
                        }
                    }
                    params(function (parameters) {
                        console.log('Ran Parameters')
                    })
                }).catch(failed);
            }
        } else {
            if (typeof next === 'function') {
                /**
                 * next: is worker, worker: is process, process: is failed
                 */
                if (worker) {
                    worker(cluster.worker.id)
                }
            } else {
                if (processes) {
                    processes(cluster.worker.id)
                }
            }
        }
    },
    InstanceItem: require('./lib/index').InstanceItem,
    None: require('./lib/index').None,
    Dynamo: require('aws-generator').Dynamo,
    Generator : require('aws-generator'),
    S3Wrapper: require('./lib/S3Wrapper')
};
